=== debian/changelog ===
ogre-1.8 (1.8.1+dfsg-0ubuntu3) trusty; urgency=low

  * Added override_dh_links to debian/rules to create symlink for plugins from
    OGRE-1.8.1 to OGRE-1.8.0 (LP: #1244592)

 -- Scott Howard <showard@debian.org>  Fri, 25 Oct 2013 20:09:06 -0400

ogre-1.8 (1.8.1+dfsg-0ubuntu2) trusty; urgency=low

  * Bump to Boost 1.54.

 -- Dmitrijs Ledkovs <xnox@ubuntu.com>  Sat, 26 Oct 2013 22:26:43 +0100

ogre-1.8 (1.8.1+dfsg-0ubuntu1) saucy; urgency=low

  * New upstream release

 -- Dmitrijs Ledkovs <dmitrij.ledkov@ubuntu.com>  Tue, 26 Mar 2013 12:12:34 +0000

ogre-1.8 (1.8.0+dfsg1-3ubuntu1) s-release; urgency=low

  * Boost 1.53.

 -- Dmitrijs Ledkovs <dmitrij.ledkov@ubuntu.com>  Tue, 26 Mar 2013 11:37:04 +0000
