=== debian/watch ===
# format version number, currently 3; this line is compulsory!
version=3

opts=uversionmangle=s/-/./g,dversionmangle=s/\.dfsg\d+// http://sf.net/ogre/ogre.*v(\d+)-(\d+)-(\d+)\.tar\.bz2
